proc glm data=&base;
	class hs6;
	model dlp2=hs6 s2hat pshat /noint solution  ;
	ods output ParameterEstimates=work.&sol ;* &sol contains the parameter estimates (4coef+42 intercepts);
run;quit;
* compute residuals of the constrained estimation;
data EF;
	set &sol;
	if Parameter="s2hat" then delete;
	if Parameter="pshat" then delete;
	hs6=substr(Parameter,11,6);
run;* keep the sector-specific intercepts;
proc sort data=EF;
	by hs6;
proc sort data=&base;
	by hs6;
data &base;
	merge &base EF(keep=hs6 estimate);* add sector-specific intercepts in base;
	by hs6;
	merge=1;
data s2hat;
	set &sol;
	where Parameter="s2hat";
	merge=1;
	coef_s2hat=estimate;
data pshat;
	set &sol;
	where Parameter="pshat";
	merge=1;
	coef_pshat=estimate;
proc sort data=&base;
	by merge;
proc sort data=s2hat;
	by merge;
proc sort data=pshat;
	by merge;
data &base;
	merge &base s2hat(keep=coef_s2hat merge) pshat(keep=coef_pshat merge) ;
	by merge;* add estimated coef in base;
	res=dlp2-estimate-coef_s2hat*dls2-coef_pshat*dlps;
	res2=res*res;
run;
